HDU 2485 Destroying the bus stations

2015 ACM / ICPC 北京站 热身赛 C题

#include<cstdio>
#include<cstring>
#include<cmath>
#include<queue>
#include<vector>
#include<algorithm>
using namespace std;

const int INF=0x7FFFFFFF;
const int maxn=50+10;//点的数量
int n,m,k;
int u[4000+10],v[4000+10];
int dis1[maxn],dis2[maxn];
bool flag1[maxn],flag2[maxn];
vector<int>P[maxn];
vector<int>FP[maxn];
queue<int>Q1;
queue<int>Q2;

struct Edge
{
    int from, to, cap, flow;
    Edge(int u, int v, int c, int f) :from(u), to(v), cap(c), flow(f) {}
};
vector<Edge>edges;
vector<int>G[maxn*2];
bool vis[maxn*2];
int d[maxn*2];
int cur[maxn*2];
int s, t;

void read()
{
    for(int i=1;i<=m;i++)
    {
        scanf("%d%d",&u[i],&v[i]);
        P[u[i]].push_back(v[i]);
        FP[v[i]].push_back(u[i]);
    }
}

void init()
{
    for(int i=0;i<maxn;i++) P[i].clear();
    for(int i=0;i<maxn;i++) FP[i].clear();

    for(int i=1;i<=n;i++) dis1[i]=INF,dis2[i]=INF;

    for(int i = 0; i < 2*maxn; i++) G[i].clear();
    edges.clear();
}

void AddEdge(int from, int to, int cap)
{
    edges.push_back(Edge(from, to, cap, 0));
    edges.push_back(Edge(to, from, 0, 0));
    int w = edges.size();
    G[from].push_back(w - 2);
    G[to].push_back(w - 1);
}

bool BFS()
{
    memset(vis, 0, sizeof(vis));
    queue<int>Q;
    Q.push(s);
    d[s] = 0;
    vis[s] = 1;
    while (!Q.empty())
    {
        int x = Q.front();
        Q.pop();
        for (int i = 0; i<G[x].size(); i++)
        {
            Edge e = edges[G[x][i]];
            if (!vis[e.to] && e.cap>e.flow)
            {
                vis[e.to] = 1;
                d[e.to] = d[x] + 1;
                Q.push(e.to);
            }
        }
    }
    return vis[t];
}

int DFS(int x, int a)
{
    if (x == t || a == 0)
        return a;
    int flow = 0, f;
    for (int &i = cur[x]; i<G[x].size(); i++)
    {
        Edge e = edges[G[x][i]];
        if (d[x]+1 == d[e.to]&&(f=DFS(e.to,min(a,e.cap-e.flow)))>0)
        {
            edges[G[x][i]].flow+=f;
            edges[G[x][i] ^ 1].flow-=f;
            flow+=f;
            a-=f;
            if(a==0) break;
        }
    }
    if(!flow) d[x] = -1;
    return flow;
}

int dinic(int s, int t)
{
    int flow = 0;
    while (BFS())
    {
        memset(cur, 0, sizeof(cur));
        flow += DFS(s, INF);
    }
    return flow;
}

void spfa1(int x)
{
    while(!Q1.empty()) Q1.pop();
    memset(flag1,0,sizeof flag1);

    dis1[x]=0;
    flag1[x]=1;
    Q1.push(x);

    while(!Q1.empty())
    {
        int h=Q1.front(); flag1[h]=0; Q1.pop();
        for(int i=0;i<P[h].size();i++)
        {
            if(dis1[h]+1<dis1[P[h][i]])
            {
                dis1[P[h][i]]=dis1[h]+1;
                if(flag1[P[h][i]]==0)
                {
                    flag1[P[h][i]]=1;
                    Q1.push(P[h][i]);
                }
            }
        }
    }
}

void spfa2(int x)
{
    while(!Q2.empty()) Q2.pop();
    memset(flag2,0,sizeof flag2);

    dis2[x]=0;
    flag2[x]=1;
    Q2.push(x);

    while(!Q2.empty())
    {
        int h=Q2.front(); flag2[h]=0; Q2.pop();
        for(int i=0;i<FP[h].size();i++)
        {
            if(dis2[h]+1<dis2[FP[h][i]])
            {
                dis2[FP[h][i]]=dis2[h]+1;
                if(flag2[FP[h][i]]==0)
                {
                    flag2[FP[h][i]]=1;
                    Q2.push(FP[h][i]);
                }
            }
        }
    }
}

int main()
{
    while(~scanf("%d%d%d",&n,&m,&k))
    {
        if(!n&&!m&&!k) break;

        init();
        read();

        spfa1(1);
        spfa2(n);

        s=1;t=n+n;

        for(int i=1;i<=n;i++) AddEdge(i+n,i,1);

        for(int i=1;i<=m;i++)
            if(dis1[u[i]]+dis2[v[i]]+1<=k)
                AddEdge(u[i],v[i]+n,INF);

        int ans=dinic(s,t);
        printf("%d\n",ans);
    }
    return 0;
}
时间: 2024-11-08 23:33:47

HDU 2485 Destroying the bus stations的相关文章

hdu 2485 Destroying the bus stations 迭代加深搜索

求最少去掉几个公交站使得从s到t的最短路径大于k. 迭代加深搜索. #include <cstdio> #include <cstring> #include <queue> using namespace std; #define maxn 60 #define maxm 50000 int n,m,K,cnt,up; int head[maxn],pre[maxn]; int road[maxn][maxn]; bool del[maxn]; queue<in

HDU 2485 Destroying the bus stations(费用流)

http://acm.hdu.edu.cn/showproblem.php?pid=2485 题意: 现在要从起点1到终点n,途中有多个车站,每经过一个车站为1时间,现在要在k时间内到达终点,问至少要破坏多少个车站. 思路: 把每个点拆分为两个点,容量为1,费用为0.之后相邻的车站连边,容量为INF,费用为1,表示经过一个车站需要1时间. 这样一来,跑一遍费用流计算出在费用不大于k的情况下的最大流,也就是最小割,即至少要破坏的车站数. 在网络中寻求关于f的最小费用增广路,就等价于在伴随网络中寻求

hdu 2485 Destroying the bus stations 最小费用最大流

题意: 最少需要几个点才能使得有向图中1->n的距离大于k. 分析: 删除某一点的以后,与它相连的所有边都不存在了,相当于点的容量为1.但是在网络流中我们只能直接限制边的容量.所以需要拆点来完成对的点容量的限制.对于边i -> j,先建边i ->i',再建i'->j.i ->i'只能建一次,容量为1,费用为0.i'->j的容量是INF.此题中因为已经有源点,所以源点(1)不能限制容量. 1 #include<iostream> 2 #include<c

Destroying the bus stations (hdu 2485 网络流+最短路)

Destroying the bus stations Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2313    Accepted Submission(s): 739 Problem Description Gabiluso is one of the greatest spies in his country. Now he'

Destroying the bus stations

hdu2485:http://acm.hdu.edu.cn/showproblem.php?pid=2485 题意:给你一个图,让你删除其中的一些点,然后使得1到n的最小距离大于k,求删除的最小的点数. 题解:DFS枚举最短路径上的点. 1 #include<iostream> 2 #include<cstdio> 3 #include<cstring> 4 #include<algorithm> 5 #include<queue> 6 #def

HDUOJ----2485 Destroying the bus stations

Destroying the bus stations Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2072    Accepted Submission(s): 647 Problem Description Gabiluso is one of the greatest spies in his country. Now he'

HDU2485 Destroying the bus stations(最小割---点割)

Destroying the bus stations Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2319    Accepted Submission(s): 743 Problem Description Gabiluso is one of the greatest spies in his country. Now he'

hdu 2485 Highways

题意:Flatopia岛要修路,这个岛上有n个城市,要求修完路后,各城市之间可以相互到达,且修的总路程最短.求所修路中的最长的路段 最小生成树的一道题,很裸的一道题,不知道为什么就是编译过不了. #include<iostream> #include<cstdlib> #include<cstring> #include<algorithm> using namespace std; int w[200000],u[200000],v[200000],p[5

HDU 2485

http://acm.hdu.edu.cn/showproblem.php?pid=2485 n个车站,m条边,两边之间费用为1,问最少摧毁多少车站,使得1-n无法在k时间内到达 将2-(n-1)每个点拆成两个,并建立容量为1,费用为0的一条边,源点为1,汇点为2*n-2,这时求最小费用最大流,其中保证dis[t]<=k,求得的最大流即为摧毁的车站数量(因为1流量代表能从其中一个车站到达n点) #include <iostream> #include <cstdio> #in